# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from .. import outputs as _root_outputs

__all__ = [
    'GetTrafficMirrorFilterRuleResult',
    'AwaitableGetTrafficMirrorFilterRuleResult',
    'get_traffic_mirror_filter_rule',
    'get_traffic_mirror_filter_rule_output',
]

@pulumi.output_type
class GetTrafficMirrorFilterRuleResult:
    def __init__(__self__, description=None, destination_cidr_block=None, destination_port_range=None, protocol=None, rule_action=None, rule_number=None, source_cidr_block=None, source_port_range=None, tags=None, traffic_direction=None, traffic_mirror_filter_rule_id=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if destination_cidr_block and not isinstance(destination_cidr_block, str):
            raise TypeError("Expected argument 'destination_cidr_block' to be a str")
        pulumi.set(__self__, "destination_cidr_block", destination_cidr_block)
        if destination_port_range and not isinstance(destination_port_range, dict):
            raise TypeError("Expected argument 'destination_port_range' to be a dict")
        pulumi.set(__self__, "destination_port_range", destination_port_range)
        if protocol and not isinstance(protocol, int):
            raise TypeError("Expected argument 'protocol' to be a int")
        pulumi.set(__self__, "protocol", protocol)
        if rule_action and not isinstance(rule_action, str):
            raise TypeError("Expected argument 'rule_action' to be a str")
        pulumi.set(__self__, "rule_action", rule_action)
        if rule_number and not isinstance(rule_number, int):
            raise TypeError("Expected argument 'rule_number' to be a int")
        pulumi.set(__self__, "rule_number", rule_number)
        if source_cidr_block and not isinstance(source_cidr_block, str):
            raise TypeError("Expected argument 'source_cidr_block' to be a str")
        pulumi.set(__self__, "source_cidr_block", source_cidr_block)
        if source_port_range and not isinstance(source_port_range, dict):
            raise TypeError("Expected argument 'source_port_range' to be a dict")
        pulumi.set(__self__, "source_port_range", source_port_range)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)
        if traffic_direction and not isinstance(traffic_direction, str):
            raise TypeError("Expected argument 'traffic_direction' to be a str")
        pulumi.set(__self__, "traffic_direction", traffic_direction)
        if traffic_mirror_filter_rule_id and not isinstance(traffic_mirror_filter_rule_id, str):
            raise TypeError("Expected argument 'traffic_mirror_filter_rule_id' to be a str")
        pulumi.set(__self__, "traffic_mirror_filter_rule_id", traffic_mirror_filter_rule_id)

    @property
    @pulumi.getter
    def description(self) -> Optional[builtins.str]:
        """
        The description of the Traffic Mirror Filter rule.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="destinationCidrBlock")
    def destination_cidr_block(self) -> Optional[builtins.str]:
        """
        The destination CIDR block to assign to the Traffic Mirror rule.
        """
        return pulumi.get(self, "destination_cidr_block")

    @property
    @pulumi.getter(name="destinationPortRange")
    def destination_port_range(self) -> Optional['outputs.TrafficMirrorFilterRuleTrafficMirrorPortRange']:
        """
        The destination port range.
        """
        return pulumi.get(self, "destination_port_range")

    @property
    @pulumi.getter
    def protocol(self) -> Optional[builtins.int]:
        """
        The number of protocol, for example 17 (UDP), to assign to the Traffic Mirror rule.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="ruleAction")
    def rule_action(self) -> Optional[builtins.str]:
        """
        The action to take on the filtered traffic (accept/reject).
        """
        return pulumi.get(self, "rule_action")

    @property
    @pulumi.getter(name="ruleNumber")
    def rule_number(self) -> Optional[builtins.int]:
        """
        The number of the Traffic Mirror rule.
        """
        return pulumi.get(self, "rule_number")

    @property
    @pulumi.getter(name="sourceCidrBlock")
    def source_cidr_block(self) -> Optional[builtins.str]:
        """
        The source CIDR block to assign to the Traffic Mirror Filter rule.
        """
        return pulumi.get(self, "source_cidr_block")

    @property
    @pulumi.getter(name="sourcePortRange")
    def source_port_range(self) -> Optional['outputs.TrafficMirrorFilterRuleTrafficMirrorPortRange']:
        """
        The source port range.
        """
        return pulumi.get(self, "source_port_range")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence['_root_outputs.Tag']]:
        """
        Any tags assigned to the Traffic Mirror Filter rule.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="trafficDirection")
    def traffic_direction(self) -> Optional[builtins.str]:
        """
        The direction of traffic (ingress/egress).
        """
        return pulumi.get(self, "traffic_direction")

    @property
    @pulumi.getter(name="trafficMirrorFilterRuleId")
    def traffic_mirror_filter_rule_id(self) -> Optional[builtins.str]:
        """
        The ID of the Traffic Mirror Filter rule.
        """
        return pulumi.get(self, "traffic_mirror_filter_rule_id")


class AwaitableGetTrafficMirrorFilterRuleResult(GetTrafficMirrorFilterRuleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTrafficMirrorFilterRuleResult(
            description=self.description,
            destination_cidr_block=self.destination_cidr_block,
            destination_port_range=self.destination_port_range,
            protocol=self.protocol,
            rule_action=self.rule_action,
            rule_number=self.rule_number,
            source_cidr_block=self.source_cidr_block,
            source_port_range=self.source_port_range,
            tags=self.tags,
            traffic_direction=self.traffic_direction,
            traffic_mirror_filter_rule_id=self.traffic_mirror_filter_rule_id)


def get_traffic_mirror_filter_rule(traffic_mirror_filter_rule_id: Optional[builtins.str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTrafficMirrorFilterRuleResult:
    """
    Resource Type definition for for AWS::EC2::TrafficMirrorFilterRule


    :param builtins.str traffic_mirror_filter_rule_id: The ID of the Traffic Mirror Filter rule.
    """
    __args__ = dict()
    __args__['trafficMirrorFilterRuleId'] = traffic_mirror_filter_rule_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:ec2:getTrafficMirrorFilterRule', __args__, opts=opts, typ=GetTrafficMirrorFilterRuleResult).value

    return AwaitableGetTrafficMirrorFilterRuleResult(
        description=pulumi.get(__ret__, 'description'),
        destination_cidr_block=pulumi.get(__ret__, 'destination_cidr_block'),
        destination_port_range=pulumi.get(__ret__, 'destination_port_range'),
        protocol=pulumi.get(__ret__, 'protocol'),
        rule_action=pulumi.get(__ret__, 'rule_action'),
        rule_number=pulumi.get(__ret__, 'rule_number'),
        source_cidr_block=pulumi.get(__ret__, 'source_cidr_block'),
        source_port_range=pulumi.get(__ret__, 'source_port_range'),
        tags=pulumi.get(__ret__, 'tags'),
        traffic_direction=pulumi.get(__ret__, 'traffic_direction'),
        traffic_mirror_filter_rule_id=pulumi.get(__ret__, 'traffic_mirror_filter_rule_id'))
def get_traffic_mirror_filter_rule_output(traffic_mirror_filter_rule_id: Optional[pulumi.Input[builtins.str]] = None,
                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTrafficMirrorFilterRuleResult]:
    """
    Resource Type definition for for AWS::EC2::TrafficMirrorFilterRule


    :param builtins.str traffic_mirror_filter_rule_id: The ID of the Traffic Mirror Filter rule.
    """
    __args__ = dict()
    __args__['trafficMirrorFilterRuleId'] = traffic_mirror_filter_rule_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:ec2:getTrafficMirrorFilterRule', __args__, opts=opts, typ=GetTrafficMirrorFilterRuleResult)
    return __ret__.apply(lambda __response__: GetTrafficMirrorFilterRuleResult(
        description=pulumi.get(__response__, 'description'),
        destination_cidr_block=pulumi.get(__response__, 'destination_cidr_block'),
        destination_port_range=pulumi.get(__response__, 'destination_port_range'),
        protocol=pulumi.get(__response__, 'protocol'),
        rule_action=pulumi.get(__response__, 'rule_action'),
        rule_number=pulumi.get(__response__, 'rule_number'),
        source_cidr_block=pulumi.get(__response__, 'source_cidr_block'),
        source_port_range=pulumi.get(__response__, 'source_port_range'),
        tags=pulumi.get(__response__, 'tags'),
        traffic_direction=pulumi.get(__response__, 'traffic_direction'),
        traffic_mirror_filter_rule_id=pulumi.get(__response__, 'traffic_mirror_filter_rule_id')))
