# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccountPolicyPolicyType',
    'AccountPolicyScope',
    'IntegrationStatus',
    'IntegrationType',
    'LogAnomalyDetectorEvaluationFrequency',
    'LogGroupClass',
    'MetricFilterMetricTransformationUnit',
    'QueryDefinitionQueryLanguage',
    'SubscriptionFilterDistribution',
    'TransformerEventSource',
    'TransformerOcsfVersion',
    'TransformerProcessorListToMapPropertiesFlattenedElement',
    'TransformerTypeConverterEntryType',
]


@pulumi.type_token("aws-native:logs:AccountPolicyPolicyType")
class AccountPolicyPolicyType(builtins.str, Enum):
    """
    Type of the policy.
    """
    DATA_PROTECTION_POLICY = "DATA_PROTECTION_POLICY"
    SUBSCRIPTION_FILTER_POLICY = "SUBSCRIPTION_FILTER_POLICY"
    FIELD_INDEX_POLICY = "FIELD_INDEX_POLICY"
    TRANSFORMER_POLICY = "TRANSFORMER_POLICY"


@pulumi.type_token("aws-native:logs:AccountPolicyScope")
class AccountPolicyScope(builtins.str, Enum):
    """
    Scope for policy application
    """
    ALL = "ALL"


@pulumi.type_token("aws-native:logs:IntegrationStatus")
class IntegrationStatus(builtins.str, Enum):
    """
    Status of creation for the Integration and its resources
    """
    PROVISIONING = "PROVISIONING"
    ACTIVE = "ACTIVE"
    FAILED = "FAILED"


@pulumi.type_token("aws-native:logs:IntegrationType")
class IntegrationType(builtins.str, Enum):
    """
    The type of the Integration.
    """
    OPENSEARCH = "OPENSEARCH"


@pulumi.type_token("aws-native:logs:LogAnomalyDetectorEvaluationFrequency")
class LogAnomalyDetectorEvaluationFrequency(builtins.str, Enum):
    """
    How often log group is evaluated
    """
    FIVE_MIN = "FIVE_MIN"
    TEN_MIN = "TEN_MIN"
    FIFTEEN_MIN = "FIFTEEN_MIN"
    THIRTY_MIN = "THIRTY_MIN"
    ONE_HOUR = "ONE_HOUR"


@pulumi.type_token("aws-native:logs:LogGroupClass")
class LogGroupClass(builtins.str, Enum):
    """
    Specifies the log group class for this log group. There are two classes:
      +  The ``Standard`` log class supports all CWL features.
      +  The ``Infrequent Access`` log class supports a subset of CWL features and incurs lower costs.
      
     For details about the features supported by each class, see [Log classes](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/CloudWatch_Logs_Log_Classes.html)
    """
    STANDARD = "STANDARD"
    INFREQUENT_ACCESS = "INFREQUENT_ACCESS"
    DELIVERY = "DELIVERY"


@pulumi.type_token("aws-native:logs:MetricFilterMetricTransformationUnit")
class MetricFilterMetricTransformationUnit(builtins.str, Enum):
    """
    The unit to assign to the metric. If you omit this, the unit is set as ``None``.
    """
    SECONDS = "Seconds"
    MICROSECONDS = "Microseconds"
    MILLISECONDS = "Milliseconds"
    BYTES = "Bytes"
    KILOBYTES = "Kilobytes"
    MEGABYTES = "Megabytes"
    GIGABYTES = "Gigabytes"
    TERABYTES = "Terabytes"
    BITS = "Bits"
    KILOBITS = "Kilobits"
    MEGABITS = "Megabits"
    GIGABITS = "Gigabits"
    TERABITS = "Terabits"
    PERCENT = "Percent"
    COUNT = "Count"
    BYTES_SECOND = "Bytes/Second"
    KILOBYTES_SECOND = "Kilobytes/Second"
    MEGABYTES_SECOND = "Megabytes/Second"
    GIGABYTES_SECOND = "Gigabytes/Second"
    TERABYTES_SECOND = "Terabytes/Second"
    BITS_SECOND = "Bits/Second"
    KILOBITS_SECOND = "Kilobits/Second"
    MEGABITS_SECOND = "Megabits/Second"
    GIGABITS_SECOND = "Gigabits/Second"
    TERABITS_SECOND = "Terabits/Second"
    COUNT_SECOND = "Count/Second"
    NONE = "None"


@pulumi.type_token("aws-native:logs:QueryDefinitionQueryLanguage")
class QueryDefinitionQueryLanguage(builtins.str, Enum):
    """
    Query language of the query string. Possible values are CWLI, SQL, PPL, with CWLI being the default.
    """
    CWLI = "CWLI"
    SQL = "SQL"
    PPL = "PPL"


@pulumi.type_token("aws-native:logs:SubscriptionFilterDistribution")
class SubscriptionFilterDistribution(builtins.str, Enum):
    """
    The method used to distribute log data to the destination, which can be either random or grouped by log stream.
    """
    RANDOM = "Random"
    BY_LOG_STREAM = "ByLogStream"


@pulumi.type_token("aws-native:logs:TransformerEventSource")
class TransformerEventSource(builtins.str, Enum):
    CLOUD_TRAIL = "CloudTrail"
    ROUTE53_RESOLVER = "Route53Resolver"
    VPC_FLOW = "VPCFlow"
    EKS_AUDIT = "EKSAudit"
    AWSWAF = "AWSWAF"


@pulumi.type_token("aws-native:logs:TransformerOcsfVersion")
class TransformerOcsfVersion(builtins.str, Enum):
    V11 = "V1.1"


@pulumi.type_token("aws-native:logs:TransformerProcessorListToMapPropertiesFlattenedElement")
class TransformerProcessorListToMapPropertiesFlattenedElement(builtins.str, Enum):
    FIRST = "first"
    LAST = "last"


@pulumi.type_token("aws-native:logs:TransformerTypeConverterEntryType")
class TransformerTypeConverterEntryType(builtins.str, Enum):
    BOOLEAN = "boolean"
    INTEGER = "integer"
    DOUBLE = "double"
    STRING = "string"
