# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AssociationComplianceSeverity',
    'AssociationSyncCompliance',
    'DocumentAttachmentsSourceKey',
    'DocumentFormat',
    'DocumentType',
    'DocumentUpdateMethod',
    'ParameterDataType',
    'ParameterTier',
    'ParameterType',
    'PatchBaselineApprovedPatchesComplianceLevel',
    'PatchBaselineOperatingSystem',
    'PatchBaselinePatchFilterKey',
    'PatchBaselineRejectedPatchesAction',
    'PatchBaselineRuleComplianceLevel',
]


@pulumi.type_token("aws-native:ssm:AssociationComplianceSeverity")
class AssociationComplianceSeverity(builtins.str, Enum):
    """
    The severity level that is assigned to the association.
    """
    CRITICAL = "CRITICAL"
    HIGH = "HIGH"
    MEDIUM = "MEDIUM"
    LOW = "LOW"
    UNSPECIFIED = "UNSPECIFIED"


@pulumi.type_token("aws-native:ssm:AssociationSyncCompliance")
class AssociationSyncCompliance(builtins.str, Enum):
    """
    The mode for generating association compliance. You can specify `AUTO` or `MANUAL` . In `AUTO` mode, the system uses the status of the association execution to determine the compliance status. If the association execution runs successfully, then the association is `COMPLIANT` . If the association execution doesn't run successfully, the association is `NON-COMPLIANT` .

    In `MANUAL` mode, you must specify the `AssociationId` as a parameter for the `PutComplianceItems` API action. In this case, compliance data is not managed by State Manager. It is managed by your direct call to the `PutComplianceItems` API action.

    By default, all associations use `AUTO` mode.
    """
    AUTO = "AUTO"
    MANUAL = "MANUAL"


@pulumi.type_token("aws-native:ssm:DocumentAttachmentsSourceKey")
class DocumentAttachmentsSourceKey(builtins.str, Enum):
    """
    The key of a key-value pair that identifies the location of an attachment to a document.
    """
    SOURCE_URL = "SourceUrl"
    S3_FILE_URL = "S3FileUrl"
    ATTACHMENT_REFERENCE = "AttachmentReference"


@pulumi.type_token("aws-native:ssm:DocumentFormat")
class DocumentFormat(builtins.str, Enum):
    """
    Specify the document format for the request. The document format can be either JSON or YAML. JSON is the default format.
    """
    YAML = "YAML"
    JSON = "JSON"
    TEXT = "TEXT"


@pulumi.type_token("aws-native:ssm:DocumentType")
class DocumentType(builtins.str, Enum):
    """
    The type of document to create.
    """
    APPLICATION_CONFIGURATION = "ApplicationConfiguration"
    APPLICATION_CONFIGURATION_SCHEMA = "ApplicationConfigurationSchema"
    AUTOMATION = "Automation"
    AUTOMATION_CHANGE_TEMPLATE = "Automation.ChangeTemplate"
    AUTO_APPROVAL_POLICY = "AutoApprovalPolicy"
    CHANGE_CALENDAR = "ChangeCalendar"
    CLOUD_FORMATION = "CloudFormation"
    COMMAND = "Command"
    DEPLOYMENT_STRATEGY = "DeploymentStrategy"
    MANUAL_APPROVAL_POLICY = "ManualApprovalPolicy"
    PACKAGE = "Package"
    POLICY = "Policy"
    PROBLEM_ANALYSIS = "ProblemAnalysis"
    PROBLEM_ANALYSIS_TEMPLATE = "ProblemAnalysisTemplate"
    SESSION = "Session"


@pulumi.type_token("aws-native:ssm:DocumentUpdateMethod")
class DocumentUpdateMethod(builtins.str, Enum):
    """
    Update method - when set to 'Replace', the update will replace the existing document; when set to 'NewVersion', the update will create a new version.
    """
    REPLACE = "Replace"
    NEW_VERSION = "NewVersion"


@pulumi.type_token("aws-native:ssm:ParameterDataType")
class ParameterDataType(builtins.str, Enum):
    """
    The data type of the parameter, such as ``text`` or ``aws:ec2:image``. The default is ``text``.
    """
    TEXT = "text"
    AWSEC2IMAGE = "aws:ec2:image"


@pulumi.type_token("aws-native:ssm:ParameterTier")
class ParameterTier(builtins.str, Enum):
    """
    The parameter tier.
    """
    STANDARD = "Standard"
    ADVANCED = "Advanced"
    INTELLIGENT_TIERING = "Intelligent-Tiering"


@pulumi.type_token("aws-native:ssm:ParameterType")
class ParameterType(builtins.str, Enum):
    """
    The type of parameter.
    """
    STRING = "String"
    STRING_LIST = "StringList"


@pulumi.type_token("aws-native:ssm:PatchBaselineApprovedPatchesComplianceLevel")
class PatchBaselineApprovedPatchesComplianceLevel(builtins.str, Enum):
    """
    Defines the compliance level for approved patches. This means that if an approved patch is reported as missing, this is the severity of the compliance violation. The default value is UNSPECIFIED.
    """
    CRITICAL = "CRITICAL"
    HIGH = "HIGH"
    MEDIUM = "MEDIUM"
    LOW = "LOW"
    INFORMATIONAL = "INFORMATIONAL"
    UNSPECIFIED = "UNSPECIFIED"


@pulumi.type_token("aws-native:ssm:PatchBaselineOperatingSystem")
class PatchBaselineOperatingSystem(builtins.str, Enum):
    """
    Defines the operating system the patch baseline applies to. The Default value is WINDOWS.
    """
    WINDOWS = "WINDOWS"
    AMAZON_LINUX = "AMAZON_LINUX"
    AMAZON_LINUX2 = "AMAZON_LINUX_2"
    AMAZON_LINUX2022 = "AMAZON_LINUX_2022"
    AMAZON_LINUX2023 = "AMAZON_LINUX_2023"
    UBUNTU = "UBUNTU"
    REDHAT_ENTERPRISE_LINUX = "REDHAT_ENTERPRISE_LINUX"
    SUSE = "SUSE"
    CENTOS = "CENTOS"
    ORACLE_LINUX = "ORACLE_LINUX"
    DEBIAN = "DEBIAN"
    MACOS = "MACOS"
    RASPBIAN = "RASPBIAN"
    ROCKY_LINUX = "ROCKY_LINUX"
    ALMA_LINUX = "ALMA_LINUX"


@pulumi.type_token("aws-native:ssm:PatchBaselinePatchFilterKey")
class PatchBaselinePatchFilterKey(builtins.str, Enum):
    """
    The key for the filter.

    For information about valid keys, see [PatchFilter](https://docs.aws.amazon.com/systems-manager/latest/APIReference/API_PatchFilter.html) in the *AWS Systems Manager API Reference* .
    """
    ADVISORY_ID = "ADVISORY_ID"
    ARCH = "ARCH"
    BUGZILLA_ID = "BUGZILLA_ID"
    CLASSIFICATION = "CLASSIFICATION"
    CVE_ID = "CVE_ID"
    EPOCH = "EPOCH"
    MSRC_SEVERITY = "MSRC_SEVERITY"
    NAME = "NAME"
    PATCH_ID = "PATCH_ID"
    PATCH_SET = "PATCH_SET"
    PRIORITY = "PRIORITY"
    PRODUCT = "PRODUCT"
    PRODUCT_FAMILY = "PRODUCT_FAMILY"
    RELEASE = "RELEASE"
    REPOSITORY = "REPOSITORY"
    SECTION = "SECTION"
    SECURITY = "SECURITY"
    SEVERITY = "SEVERITY"
    VERSION = "VERSION"


@pulumi.type_token("aws-native:ssm:PatchBaselineRejectedPatchesAction")
class PatchBaselineRejectedPatchesAction(builtins.str, Enum):
    """
    The action for Patch Manager to take on patches included in the RejectedPackages list.
    """
    ALLOW_AS_DEPENDENCY = "ALLOW_AS_DEPENDENCY"
    BLOCK = "BLOCK"


@pulumi.type_token("aws-native:ssm:PatchBaselineRuleComplianceLevel")
class PatchBaselineRuleComplianceLevel(builtins.str, Enum):
    """
    A compliance severity level for all approved patches in a patch baseline. Valid compliance severity levels include the following: `UNSPECIFIED` , `CRITICAL` , `HIGH` , `MEDIUM` , `LOW` , and `INFORMATIONAL` .
    """
    CRITICAL = "CRITICAL"
    HIGH = "HIGH"
    INFORMATIONAL = "INFORMATIONAL"
    LOW = "LOW"
    MEDIUM = "MEDIUM"
    UNSPECIFIED = "UNSPECIFIED"
