# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AgreementEnforceMessageSigning',
    'AgreementPreserveFilename',
    'AgreementStatus',
    'CertificateStatus',
    'CertificateType',
    'CertificateUsage',
    'ConnectorAs2ConfigPropertiesCompression',
    'ConnectorAs2ConfigPropertiesEncryptionAlgorithm',
    'ConnectorAs2ConfigPropertiesMdnResponse',
    'ConnectorAs2ConfigPropertiesMdnSigningAlgorithm',
    'ConnectorAs2ConfigPropertiesPreserveContentType',
    'ConnectorAs2ConfigPropertiesSigningAlgorithm',
    'ProfileType',
    'ServerAs2Transport',
    'ServerDirectoryListingOptimization',
    'ServerDomain',
    'ServerEndpointType',
    'ServerIdentityProviderType',
    'ServerProtocol',
    'ServerSetStatOption',
    'ServerSftpAuthenticationMethods',
    'ServerState',
    'ServerTlsSessionResumptionMode',
    'UserHomeDirectoryType',
    'UserMapType',
    'WebAppEndpointPolicy',
    'WorkflowStepCopyStepDetailsPropertiesOverwriteExisting',
    'WorkflowStepDecryptStepDetailsPropertiesOverwriteExisting',
    'WorkflowStepDecryptStepDetailsPropertiesType',
    'WorkflowStepType',
]


@pulumi.type_token("aws-native:transfer:AgreementEnforceMessageSigning")
class AgreementEnforceMessageSigning(builtins.str, Enum):
    """
    Specifies whether to enforce an AS2 message is signed for this agreement.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:transfer:AgreementPreserveFilename")
class AgreementPreserveFilename(builtins.str, Enum):
    """
    Specifies whether to preserve the filename received for this agreement.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:transfer:AgreementStatus")
class AgreementStatus(builtins.str, Enum):
    """
    Specifies the status of the agreement.
    """
    ACTIVE = "ACTIVE"
    INACTIVE = "INACTIVE"


@pulumi.type_token("aws-native:transfer:CertificateStatus")
class CertificateStatus(builtins.str, Enum):
    """
    A status description for the certificate.
    """
    ACTIVE = "ACTIVE"
    PENDING = "PENDING"
    INACTIVE = "INACTIVE"


@pulumi.type_token("aws-native:transfer:CertificateType")
class CertificateType(builtins.str, Enum):
    """
    Describing the type of certificate. With or without a private key.
    """
    CERTIFICATE = "CERTIFICATE"
    CERTIFICATE_WITH_PRIVATE_KEY = "CERTIFICATE_WITH_PRIVATE_KEY"


@pulumi.type_token("aws-native:transfer:CertificateUsage")
class CertificateUsage(builtins.str, Enum):
    """
    Specifies the usage type for the certificate.
    """
    SIGNING = "SIGNING"
    ENCRYPTION = "ENCRYPTION"
    TLS = "TLS"


@pulumi.type_token("aws-native:transfer:ConnectorAs2ConfigPropertiesCompression")
class ConnectorAs2ConfigPropertiesCompression(builtins.str, Enum):
    """
    Compression setting for this AS2 connector configuration.
    """
    ZLIB = "ZLIB"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:transfer:ConnectorAs2ConfigPropertiesEncryptionAlgorithm")
class ConnectorAs2ConfigPropertiesEncryptionAlgorithm(builtins.str, Enum):
    """
    Encryption algorithm for this AS2 connector configuration.
    """
    AES128_CBC = "AES128_CBC"
    AES192_CBC = "AES192_CBC"
    AES256_CBC = "AES256_CBC"
    NONE = "NONE"
    DES_EDE3_CBC = "DES_EDE3_CBC"


@pulumi.type_token("aws-native:transfer:ConnectorAs2ConfigPropertiesMdnResponse")
class ConnectorAs2ConfigPropertiesMdnResponse(builtins.str, Enum):
    """
    MDN Response setting for this AS2 connector configuration.
    """
    SYNC = "SYNC"
    NONE = "NONE"


@pulumi.type_token("aws-native:transfer:ConnectorAs2ConfigPropertiesMdnSigningAlgorithm")
class ConnectorAs2ConfigPropertiesMdnSigningAlgorithm(builtins.str, Enum):
    """
    MDN Signing algorithm for this AS2 connector configuration.
    """
    SHA256 = "SHA256"
    SHA384 = "SHA384"
    SHA512 = "SHA512"
    SHA1 = "SHA1"
    NONE = "NONE"
    DEFAULT = "DEFAULT"


@pulumi.type_token("aws-native:transfer:ConnectorAs2ConfigPropertiesPreserveContentType")
class ConnectorAs2ConfigPropertiesPreserveContentType(builtins.str, Enum):
    """
    Specifies whether to use the AWS S3 object content-type as the content-type for the AS2 message.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:transfer:ConnectorAs2ConfigPropertiesSigningAlgorithm")
class ConnectorAs2ConfigPropertiesSigningAlgorithm(builtins.str, Enum):
    """
    Signing algorithm for this AS2 connector configuration.
    """
    SHA256 = "SHA256"
    SHA384 = "SHA384"
    SHA512 = "SHA512"
    SHA1 = "SHA1"
    NONE = "NONE"


@pulumi.type_token("aws-native:transfer:ProfileType")
class ProfileType(builtins.str, Enum):
    """
    Enum specifying whether the profile is local or associated with a trading partner.
    """
    LOCAL = "LOCAL"
    PARTNER = "PARTNER"


@pulumi.type_token("aws-native:transfer:ServerAs2Transport")
class ServerAs2Transport(builtins.str, Enum):
    HTTP = "HTTP"


@pulumi.type_token("aws-native:transfer:ServerDirectoryListingOptimization")
class ServerDirectoryListingOptimization(builtins.str, Enum):
    """
    Indicates whether optimization to directory listing on S3 servers is used. Disabled by default for compatibility.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:transfer:ServerDomain")
class ServerDomain(builtins.str, Enum):
    S3 = "S3"
    EFS = "EFS"


@pulumi.type_token("aws-native:transfer:ServerEndpointType")
class ServerEndpointType(builtins.str, Enum):
    PUBLIC = "PUBLIC"
    VPC = "VPC"
    VPC_ENDPOINT = "VPC_ENDPOINT"


@pulumi.type_token("aws-native:transfer:ServerIdentityProviderType")
class ServerIdentityProviderType(builtins.str, Enum):
    SERVICE_MANAGED = "SERVICE_MANAGED"
    API_GATEWAY = "API_GATEWAY"
    AWS_DIRECTORY_SERVICE = "AWS_DIRECTORY_SERVICE"
    AWS_LAMBDA = "AWS_LAMBDA"


@pulumi.type_token("aws-native:transfer:ServerProtocol")
class ServerProtocol(builtins.str, Enum):
    SFTP = "SFTP"
    FTP = "FTP"
    FTPS = "FTPS"
    AS2 = "AS2"


@pulumi.type_token("aws-native:transfer:ServerSetStatOption")
class ServerSetStatOption(builtins.str, Enum):
    DEFAULT = "DEFAULT"
    ENABLE_NO_OP = "ENABLE_NO_OP"


@pulumi.type_token("aws-native:transfer:ServerSftpAuthenticationMethods")
class ServerSftpAuthenticationMethods(builtins.str, Enum):
    PASSWORD = "PASSWORD"
    PUBLIC_KEY = "PUBLIC_KEY"
    PUBLIC_KEY_OR_PASSWORD = "PUBLIC_KEY_OR_PASSWORD"
    PUBLIC_KEY_AND_PASSWORD = "PUBLIC_KEY_AND_PASSWORD"


@pulumi.type_token("aws-native:transfer:ServerState")
class ServerState(builtins.str, Enum):
    OFFLINE = "OFFLINE"
    ONLINE = "ONLINE"
    STARTING = "STARTING"
    STOPPING = "STOPPING"
    START_FAILED = "START_FAILED"
    STOP_FAILED = "STOP_FAILED"


@pulumi.type_token("aws-native:transfer:ServerTlsSessionResumptionMode")
class ServerTlsSessionResumptionMode(builtins.str, Enum):
    DISABLED = "DISABLED"
    ENABLED = "ENABLED"
    ENFORCED = "ENFORCED"


@pulumi.type_token("aws-native:transfer:UserHomeDirectoryType")
class UserHomeDirectoryType(builtins.str, Enum):
    PATH = "PATH"
    LOGICAL = "LOGICAL"


@pulumi.type_token("aws-native:transfer:UserMapType")
class UserMapType(builtins.str, Enum):
    FILE = "FILE"
    DIRECTORY = "DIRECTORY"


@pulumi.type_token("aws-native:transfer:WebAppEndpointPolicy")
class WebAppEndpointPolicy(builtins.str, Enum):
    STANDARD = "STANDARD"
    FIPS = "FIPS"


@pulumi.type_token("aws-native:transfer:WorkflowStepCopyStepDetailsPropertiesOverwriteExisting")
class WorkflowStepCopyStepDetailsPropertiesOverwriteExisting(builtins.str, Enum):
    """
    A flag that indicates whether or not to overwrite an existing file of the same name. The default is FALSE.
    """
    TRUE = "TRUE"
    FALSE = "FALSE"


@pulumi.type_token("aws-native:transfer:WorkflowStepDecryptStepDetailsPropertiesOverwriteExisting")
class WorkflowStepDecryptStepDetailsPropertiesOverwriteExisting(builtins.str, Enum):
    """
    A flag that indicates whether or not to overwrite an existing file of the same name. The default is FALSE.
    """
    TRUE = "TRUE"
    FALSE = "FALSE"


@pulumi.type_token("aws-native:transfer:WorkflowStepDecryptStepDetailsPropertiesType")
class WorkflowStepDecryptStepDetailsPropertiesType(builtins.str, Enum):
    """
    Specifies which encryption method to use.
    """
    PGP = "PGP"


@pulumi.type_token("aws-native:transfer:WorkflowStepType")
class WorkflowStepType(builtins.str, Enum):
    COPY = "COPY"
    CUSTOM = "CUSTOM"
    DECRYPT = "DECRYPT"
    DELETE = "DELETE"
    TAG = "TAG"
