# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['TransactionSearchConfigArgs', 'TransactionSearchConfig']

@pulumi.input_type
class TransactionSearchConfigArgs:
    def __init__(__self__, *,
                 indexing_percentage: Optional[pulumi.Input[builtins.float]] = None):
        """
        The set of arguments for constructing a TransactionSearchConfig resource.
        """
        if indexing_percentage is not None:
            pulumi.set(__self__, "indexing_percentage", indexing_percentage)

    @property
    @pulumi.getter(name="indexingPercentage")
    def indexing_percentage(self) -> Optional[pulumi.Input[builtins.float]]:
        return pulumi.get(self, "indexing_percentage")

    @indexing_percentage.setter
    def indexing_percentage(self, value: Optional[pulumi.Input[builtins.float]]):
        pulumi.set(self, "indexing_percentage", value)


@pulumi.type_token("aws-native:xray:TransactionSearchConfig")
class TransactionSearchConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 indexing_percentage: Optional[pulumi.Input[builtins.float]] = None,
                 __props__=None):
        """
        This schema provides construct and validation rules for AWS-XRay TransactionSearchConfig resource parameters.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[TransactionSearchConfigArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This schema provides construct and validation rules for AWS-XRay TransactionSearchConfig resource parameters.

        :param str resource_name: The name of the resource.
        :param TransactionSearchConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TransactionSearchConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 indexing_percentage: Optional[pulumi.Input[builtins.float]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TransactionSearchConfigArgs.__new__(TransactionSearchConfigArgs)

            __props__.__dict__["indexing_percentage"] = indexing_percentage
            __props__.__dict__["account_id"] = None
        super(TransactionSearchConfig, __self__).__init__(
            'aws-native:xray:TransactionSearchConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'TransactionSearchConfig':
        """
        Get an existing TransactionSearchConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = TransactionSearchConfigArgs.__new__(TransactionSearchConfigArgs)

        __props__.__dict__["account_id"] = None
        __props__.__dict__["indexing_percentage"] = None
        return TransactionSearchConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="indexingPercentage")
    def indexing_percentage(self) -> pulumi.Output[Optional[builtins.float]]:
        return pulumi.get(self, "indexing_percentage")

